Bug 252128 - (telepathy-haze) Review Request: telepathy-haze - A multi-protocol Libpurple connection manager for Telepathy
Review Request: telepathy-haze - A multi-protocol Libpurple connection manage...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: David Nielsen
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-08-13 22:18 EDT by Peter Gordon
Modified: 2007-11-30 17:12 EST (History)
3 users (show)

See Also:
Fixed In Version: 0.1.3-1.fc8
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-11-26 13:47:30 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
gnomeuser: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Peter Gordon 2007-08-13 22:18:19 EDT
Spec URL: http://pgordon.fedorapeople.org/for-review/telepathy-haze.spec
SRPM URL: http://pgordon.fedorapeople.org/for-review/telepathy-haze-0.1.0-1.src.rpm

Description: Haze is a connection manager for the Telepathy communications framework. It is
special in that it uses the Libpurple backend of the Pidgin instant-messaging
client for its protocol implementations. This means that Haze (in theory)
supports nearly every protocol that Pidgin does, such as AIM, MSN, and XMPP
(Jabber).
Comment 1 Peter Gordon 2007-08-17 17:05:35 EDT
I've updated it to version 0.1.1, which fixes some segfaults when closing text
and list channels, and potential g_free corruptions. 

Spec: http://pgordon.fedorapeople.org/for-review/telepathy-haze.spec
SRPM: http://pgordon.fedorapeople.org/for-review/telepathy-haze-0.1.1-1.src.rpm
Comment 2 Steve Milner 2007-08-18 20:19:42 EDT
+ rpmlint output is good
[steve@psycho ~]$ rpmlint
~/rpmbuild/RPMS/i386/telepathy-haze-mission-control-0.1.1-1.fc7.i386.rpm 
[steve@psycho ~]$ rpmlint ~/rpmbuild/RPMS/i386/telepathy-haze-0.1.1-1.fc7.i386.rpm 
[steve@psycho ~]$ 
+ Package name looks good
+ spec name looks good
+ License is GPLv2 or later
+ spec license matches license stated in code
+ License in doc
+ spec in us english
+ spec is readable
+ source matches official source
+ Compiles and builds
+ Content looks good
+ Build deps look good
- Deps seem a bit odd ... for instance ....
[steve@psycho Desktop]$ sudo rpm -ivh
~/rpmbuild/RPMS/i386/telepathy-haze-0.1.1-1.fc7.i386.rpm
~/rpmbuild/RPMS/i386/telepathy-haze-mission-control-0.1.1-1.fc7.i386.rpm 
error: Failed dependencies:
        telepathy-mission-control is needed by
telepathy-haze-mission-control-0.1.1-1.fc7.i386
[steve@psycho Desktop]$ 
+ No dupe files in rpm
+ perms look sane
+ clean exists
+ macros used
+ Does not require %doc items to run
+ install is sane
- Application runs but outputs quite a bit of warnings ...
** Message: [error] plugins: /usr/lib/purple-2/liboscar.so is not usable because
the 'purple_init_plugin' symbol could not be found.  Does the plugin call the
PURPLE_INIT_PLUGIN() macro?
** Message: [error] plugins: /usr/lib/purple-2/libsametime.so has a prefs_info,
but is a prpl. This is no longer supported.
** Message: [error] plugins: /usr/lib/purple-2/libjabber.so is not usable
because the 'purple_init_plugin' symbol could not be found.  Does the plugin
call the PURPLE_INIT_PLUGIN() macro?
** Message: [info] util: Reading file accounts.xml from directory /tmp/haze-qcKVMk
** Message: [info] util: File /tmp/haze-qcKVMk/accounts.xml does not exist (this
is not necessarily an error)
** Message: [info] util: Reading file status.xml from directory /tmp/haze-qcKVMk
** Message: [info] util: File /tmp/haze-qcKVMk/status.xml does not exist (this
is not necessarily an error)
** Message: [info] stun: using server
** Message: [info] stun: using server
** Message: [info] util: Reading file blist.xml from directory /tmp/haze-qcKVMk
** Message: [info] util: File /tmp/haze-qcKVMk/blist.xml does not exist (this is
not necessarily an error)
** Message: [info] prefs: Reading /tmp/haze-qcKVMk/prefs.xml
** Message: [info] prefs: Reading /etc/purple/prefs.xml
** Message: [info] prefs: Finished reading /etc/purple/prefs.xml
** (haze:7697): DEBUG: libpurple initialized.
** (haze:7697): DEBUG: Initializing (HazeConnectionManager *)0x9264ac0
** (haze:7697): DEBUG: started version 0.1.1 (telepathy-glib version 0.5.13)
** Message: [info] network: Entering nm_callback_func!
** (haze:7697): DEBUG: no connections, and timed out
** Message: [info] util: Writing file status.xml to directory /tmp/haze-qcKVMk
** Message: [info] util: Writing file prefs.xml to directory /tmp/haze-qcKVMk
** Message: [info] main: Unloading all plugins
** Message: [info] plugins: Unloading plugin QQ
** Message: [info] plugins: Unloading plugin XMPP
** Message: [info] plugins: Unloading plugin AIM
** Message: [info] plugins: Unloading plugin Gadu-Gadu
** Message: [info] plugins: Unloading plugin IRC
** Message: [info] plugins: Unloading plugin Yahoo
** Message: [info] plugins: Unloading plugin SILC
** Message: [info] plugins: Unloading plugin ICQ
** Message: [info] plugins: Unloading plugin Bonjour
** Message: [info] plugins: Unloading plugin SIMPLE
** Message: [info] plugins: Unloading plugin Sametime
** Message: [info] plugins: Unloading plugin Zephyr
** Message: [info] plugins: Unloading plugin GroupWise
** Message: [info] plugins: Unloading plugin MSN
** (haze:7697): DEBUG: deleting /tmp/haze-qcKVMk/status.xml
** (haze:7697): DEBUG: deleting /tmp/haze-qcKVMk/prefs.xml
** (haze:7697): DEBUG: deleting /tmp/haze-qcKVMk
Comment 3 Peter Gordon 2007-08-22 17:42:19 EDT
Thanks for the review, Steve!

(In reply to comment #2)
> - Deps seem a bit odd ... for instance ....
> [steve@psycho Desktop]$ sudo rpm -ivh
> ~/rpmbuild/RPMS/i386/telepathy-haze-0.1.1-1.fc7.i386.rpm
> ~/rpmbuild/RPMS/i386/telepathy-haze-mission-control-0.1.1-1.fc7.i386.rpm 
> error: Failed dependencies:
>         telepathy-mission-control is needed by
> telepathy-haze-mission-control-0.1.1-1.fc7.i386

Yeah, this is a subpackage which provides a profile for Mission Control, which
allows Haze (AIM, at least) to be used by it and applications which use it for
their telepathy configuration (such as Empathy).

My goal is to make Empathy and other MC apps "Just Work" with Haze as a backend;
there are profiles for Jabber and GTalk in upstream as well but those seem quite
redundant as we already have Gabble for XMPP connections.

> - Application runs but outputs quite a bit of warnings ...
> ** Message: [error] plugins: /usr/lib/purple-2/liboscar.so is not usable because
> the 'purple_init_plugin' symbol could not be found.  Does the plugin call the
> PURPLE_INIT_PLUGIN() macro?
> ** Message: [error] plugins: /usr/lib/purple-2/libsametime.so has a prefs_info,
> but is a prpl. This is no longer supported.
> ** Message: [error] plugins: /usr/lib/purple-2/libjabber.so is not usable
> because the 'purple_init_plugin' symbol could not be found.  Does the plugin
> call the PURPLE_INIT_PLUGIN() macro?

These look specific to Pidgin/libpurple; I don't get these messages when running
Empathy. :|

Comment 4 Steve Milner 2007-08-22 18:47:33 EDT
(In reply to comment #3)
> Thanks for the review, Steve!

No prob.

> (In reply to comment #2)
> > - Deps seem a bit odd ... for instance ....
> > [steve@psycho Desktop]$ sudo rpm -ivh
> > ~/rpmbuild/RPMS/i386/telepathy-haze-0.1.1-1.fc7.i386.rpm
> > ~/rpmbuild/RPMS/i386/telepathy-haze-mission-control-0.1.1-1.fc7.i386.rpm 
> > error: Failed dependencies:
> >         telepathy-mission-control is needed by
> > telepathy-haze-mission-control-0.1.1-1.fc7.i386
> 
> Yeah, this is a subpackage which provides a profile for Mission Control, which
> allows Haze (AIM, at least) to be used by it and applications which use it for
> their telepathy configuration (such as Empathy).
> 
> My goal is to make Empathy and other MC apps "Just Work" with Haze as a backend;
> there are profiles for Jabber and GTalk in upstream as well but those seem quite
> redundant as we already have Gabble for XMPP connections.

So the telepathy-mission-control dep issue is a literal different package and
not suppose to be telepathy-haze-mission-control?

> > - Application runs but outputs quite a bit of warnings ...
> > ** Message: [error] plugins: /usr/lib/purple-2/liboscar.so is not usable because
> > the 'purple_init_plugin' symbol could not be found.  Does the plugin call the
> > PURPLE_INIT_PLUGIN() macro?
> > ** Message: [error] plugins: /usr/lib/purple-2/libsametime.so has a prefs_info,
> > but is a prpl. This is no longer supported.
> > ** Message: [error] plugins: /usr/lib/purple-2/libjabber.so is not usable
> > because the 'purple_init_plugin' symbol could not be found.  Does the plugin
> > call the PURPLE_INIT_PLUGIN() macro?
> 
> These look specific to Pidgin/libpurple; I don't get these messages when running
> Empathy. :|

I should have noted that the warnings I saw came running telepathy-haze. Is
there a better way I can test it?
Comment 5 Peter Gordon 2007-08-27 12:44:01 EDT
> So the telepathy-mission-control dep issue is a literal different package and
> not suppose to be telepathy-haze-mission-control?

Correct. Apologies for the potential confusion.

> I should have noted that the warnings I saw came running telepathy-haze. Is
> there a better way I can test it?

Yeah, the telepathy-haze binary on its own simply runs and listens for D-Bus
signals which it then uses to connect and send/receive messages on its
respective supporting protocols. I recommend using a client such as Empathy or
one of the other clients listed on
http://telepathy.freedesktop.org/wiki/Components to actually interface with it.
(The recent Empathy releases needed a new version of the mission-control
backend. Now that Sindre has bumped those, I'll bump Empathy as well once my new
monitor arrives within the next day or two.)
Comment 6 Jeremy Katz 2007-09-13 17:43:25 EDT
If it's not intended to be run by the user, it may make more sense to move the 
binary to /usr/libexec.

That said, I just built and installed it and AIM showed up as a transport and
just worked in empathy.  Which is pretty cool (didn't even have to restart empathy)
Comment 7 Peter Gordon 2007-09-13 22:37:55 EDT
Thanks, Jeremy. I'm going to keep the binary in /usr/bin for the time being, as
that is where other connection managers are kept (take a look at
telepathy-gabble, telepathy-salut, et al. for example) and this is also where
other distributions (Gentoo and Debian/Ubuntu) have them stored, also.

I'll poke the Telepathy people about moving the connection manager binaries to
/usr/libexec though. Thanks for the suggestion.
Comment 8 Peter Gordon 2007-09-16 14:58:20 EDT
0.1.2 is out; I've bumped my packaging accordingly. The spec file is at the same
URL, and the source RPM is:
http://pgordon.fedorapeople.org/for-review/telepathy-haze-0.1.2-1.src.rpm

* Sun Sep 16 2007 Peter Gordon <peter@thecodergeek.com> - 0.1.2-1
- Update to new upstream release (0.1.2), which fixes sending messages with
  <, >, and & characters and properly cleans up zombie children.   

Thanks.
Comment 9 Peter Gordon 2007-10-17 18:11:08 EDT
Anyone? Anyone? Bueller? :) I'd greatly appreciate a formal review of this. Thanks.
Comment 10 David Nielsen 2007-11-01 03:21:45 EDT
Okay Peter, I'll have a swing at your spec.
Comment 11 David Nielsen 2007-11-01 03:36:29 EDT
Haze also supports msn, as the current pymsn implementation we have for
telepathy is utterly broken not to mention no release has been since april could
you enable a profile for haze to get this support?

According to upstream, msn support should be working rather well.
Comment 12 Peter Gordon 2007-11-02 00:42:01 EDT
Thanks for taking this one, David. :-)

I've added a profile to 0.1.2-2 for MSN (though I have no MSN account, so I
can't actually test to see if it works other than the config UI loading
properly). It's based on the Butterfly profile and its default server/port
information is taken from Pidgin. 

* Thu Nov 01 2007 Peter Gordon <peter@thecodergeek.com> - 0.1.2-2
- Add haze-msn.profile (based on the profile provided by the PyMSN-based
  Butterfly connection manager) so that MC-using applications (such as
  Empathy) can use the libpurple-based MSN connection manager instead of
  Butterfly, at the user's option. 


The Spec is at the same URL; and the source RPM is:
http://pgordon.fedorapeople.org/for-review/telepathy-haze-0.1.2-2.src.rpm
Comment 13 David Nielsen 2007-11-03 05:40:16 EDT
Take with grain of salt as I currently sporting a 104F fever.

== GOOD ==

+ Naming and version/release are appropriate.
+ License (GPLv2+) is Fedora-acceptable and matches the licenses of the source
files.
+ Spec file is written in American English, and is legible. 
+ Builds fine in mock (F8, x86_64); all BuildRequires are listed
without duplicates or repeats via dependencies.
+ Final file/directory ownership is good, and does not conflict with system
packages. No duplicate files are listed.
+ Files listed properly with an appropriate %defattr(...) line.
+ A %clean section exists and includes only "rm -rf %{buildroot}" as required.
+ Macro usage is consistent.
+ The buildroot is properly cleaned at the beginning of %install (via "rm -rf
%{buildroot}").
+ All filenames are valid UTF-8.
+ All desired functionality is enabled
+ rpmlint is quiet

== BLOCKERS ==
http://www.ox.compsoc.net/~resiak/ is down, thus no way to confirm the tarballs
are really the issued ones from upstream.
Comment 14 David Nielsen 2007-11-12 00:14:09 EST
Releases have been moved to:
http://telepathy.freedesktop.org/releases/telepathy-haze/

The tarballs found there have matching md5sums with those found in the srpm,
confirming to a reasonable degreee of certainty that you aren't trying to trick me.

== GOOD ==
+ MUST: rpmlint must be run on every package. The output should be posted in the
review. 
+ MUST: The package must be named according to the Package Naming Guidelines.
+ MUST: The spec file name must match the base package %{name}, in the format
%{name}.spec unless your package has an exemption on Package Naming Guidelines.
+ MUST: The package must meet the Packaging Guidelines.
+ MUST: The package must be licensed with a Fedora approved license and meet the
Licensing Guidelines.
+ MUST: The License field in the package spec file must match the actual license.
+ MUST: If (and only if) the source package includes the text of the license(s)
in its own file, then that file, containing the text of the license(s) for the
package must be included in %doc.
+ MUST: The spec file must be written in American English.
+ MUST: The spec file for the package MUST be legible. If the reviewer is unable
to read the spec file, it will be impossible to perform a review. Fedora is not
the place for entries into the Obfuscated Code Contest (http://www.ioccc.org/).
+ MUST: The sources used to build the package must match the upstream source, as
provided in the spec URL. Reviewers should use md5sum for this task. If no
upstream URL can be specified for this package, please see the Source URL
Guidelines for how to deal with this.
+ MUST: The package must successfully compile and build into binary rpms on at
least one supported architecture.
+ MUST: All build dependencies must be listed in BuildRequires, except for any
that are listed in the exceptions section of Packaging Guidelines; inclusion of
those as BuildRequires is optional. Apply common sense.
+ MUST: If the package is designed to be relocatable, the packager must state
this fact in the request for review, along with the rationalization for
relocation of that specific package. Without this, use of Prefix: /usr is
considered a blocker.
+ MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which does
create that directory. Refer to the Guidelines for examples.
+ MUST: A package must not contain any duplicate files in the %files listing.
+ MUST: Permissions on files must be set properly. Executables should be set
with executable permissions, for example. Every %files section must include a
%defattr(...) line.
+ MUST: Each package must have a %clean section, which contains rm -rf
%{buildroot} (or $RPM_BUILD_ROOT).
+ MUST: Each package must consistently use macros, as described in the macros
section of Packaging Guidelines.
+ MUST: The package must contain code, or permissable content. This is described
in detail in the code vs. content section of Packaging Guidelines.
+ MUST: If a package includes something as %doc, it must not affect the runtime
of the application. To summarize: If it is in %doc, the program must run
properly if it is not present.
+ MUST: Packages must NOT contain any .la libtool archives, these should be
removed in the spec.
+ MUST: Packages must not own files or directories already owned by other
packages. The rule of thumb here is that the first package to be installed
should own the files or directories that other packages may rely upon. This
means, for example, that no package in Fedora should ever share ownership with
any of the files or directories owned by the filesystem or man package. If you
feel that you have a good reason to own a file or directory that another package
owns, then please present that at package review time.
+ MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot}
(or $RPM_BUILD_ROOT). See Prepping BuildRoot For %install for details.
+ MUST: All filenames in rpm packages must be valid UTF-8.

== Doesn't apply ==
- MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch needs to have a bug filed
in bugzilla, describing the reason that the package does not compile/build/work
on that architecture. The bug number should then be placed in a comment, next to
the corresponding ExcludeArch line. New packages will not have bugzilla entries
during the review process, so they should put this description in the comment
until the package is approved, then file the bugzilla entry, and replace the
long explanation with the bug number. (Extras Only) The bug should be marked as
blocking one (or more) of the following bugs to simplify tracking such issues:
FE-ExcludeArch-x86, FE-ExcludeArch-x64, FE-ExcludeArch-ppc, FE-ExcludeArch-ppc64
- MUST: The spec file MUST handle locales properly. This is done by using the
%find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
- MUST: Every binary RPM package which stores shared library files (not just
symlinks) in any of the dynamic linker's default paths, must call ldconfig in
%post and %postun. If the package has multiple subpackages with libraries, each
subpackage should also have a %post/%postun section that calls /sbin/ldconfig. 
- MUST: Large documentation files should go in a -doc subpackage. (The
definition of large is left up to the packager's best judgement, but is not
restricted to size. Large can refer to either size or quantity)
- MUST: Header files must be in a -devel package.
- MUST: Static libraries must be in a -static package.
- MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for
directory ownership and usability).
- MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1),
then library files that end in .so (without suffix) must go in a -devel package.
- MUST: In the vast majority of cases, devel packages must require the base
package using a fully versioned dependency: Requires: %{name} =
%{version}-%{release} 
- MUST: Packages containing GUI applications must include a %{name}.desktop
file, and that file must be properly installed with desktop-file-install in the
%install section. This is described in detail in the desktop files section of
Packaging Guidelines. If you feel that your packaged GUI application does not
need a .desktop file, you must put a comment in the spec file with your explanation.

It seems to live up to your usual standards Peter, fix the URL before building
though, APPROVED.
Comment 15 Peter Gordon 2007-11-12 02:00:15 EST
Yay! Thanks, David. :)

New Package CVS Request
=======================
Package Name: telepathy-haze
Short Description: A multi-protocol Libpurple connection manager for Telepathy
Owners: pgordon
Branches: devel F-8 F-7
InitialCC: (none)
Cvsextras Commits: Yes
Comment 16 Kevin Fenzi 2007-11-12 12:38:18 EST
cvs done.
Comment 17 Peter Gordon 2007-11-14 20:01:55 EST
Build for rawhide; F-7 and F-8 updates in Bodhi's testing queue. Thanks for the
review!
Comment 18 Fedora Update System 2007-11-14 22:44:56 EST
telepathy-haze-0.1.2-3.fc7 has been pushed to the Fedora 7 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update telepathy-haze'
Comment 19 Fedora Update System 2007-11-15 19:36:03 EST
telepathy-haze-0.1.3-1.fc8 has been pushed to the Fedora 8 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update telepathy-haze'
Comment 20 Fedora Update System 2007-11-15 19:39:38 EST
telepathy-haze-0.1.3-1.fc7 has been pushed to the Fedora 7 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update telepathy-haze'
Comment 21 Fedora Update System 2007-11-26 13:47:28 EST
telepathy-haze-0.1.3-1.fc8 has been pushed to the Fedora 8 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 22 Fedora Update System 2007-11-26 13:48:36 EST
telepathy-haze-0.1.3-1.fc7 has been pushed to the Fedora 7 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.